;------------------------------------------------------------------------------
; CP/M 2.2 BOOT Consul 2717 pre PMD 32-SD

; RB - 23 Oct 2012
;------------------------------------------------------------------------------

BootAdr		equ	0080h
BootLen		equ	128

CcpLen		equ	0800h		; dlzka CCP
BdosLen		equ	0E00h		; dlzka BDOS

BiosAdr		equ	0CB00h		; pociatocna adresa BIOS
BdosAdr		equ	BiosAdr-BdosLen	; pociatocna adresa BDOS
CcpAdr		equ	BdosAdr-CcpLen	; pociatocna adresa CCP

DmaAdr		equ	0CFB0h		; zdrojova/cielova adresa citania/zapisu
Length		equ	0CFB2h		; dlzka citaneho bloku - 
Disk		equ	0CFB4h		; cislo disku 0 az 3
Stopa		equ	0CFB5h		; cislo stopy 0 az 76
Hlava		equ	0CFB6h		; cislo hlavy 0 alebo 1
Sektor		equ	0CFB7h		; cislo sektora 1 az 26
DskPar		equ	0CFB8h		; parametre disku
Result		equ	0CFBCh		; vysledok diskovej operacie

; rutiny v zakladnom monitore
MEMIN		equ	81B0h		; prenos obsahu pamati
; rutina pre citanie skupiny sektorov
SREAD		equ	9015h

SYS55M		equ	0F7h		; riadiaci port systemovho 8255

;------------------------------------------------------------------------------

		org	BootAdr

;------------------------------------------------------------------------------
		jmp	BootStart	; skok dopredu


;------------------------------------------------------------------------------
Signature:	db	"C2717S"	; identifikacia diskety

;------------------------------------------------------------------------------
; Start BOOT
;------------------------------------------------------------------------------
BootStart:	call	MEMIN		; odpamataj pamat od 0CFB0h pre
		dw	DmaAdr		; systemove premenne diskoveho ovladaca
		dw	12
		dw	005Ch
		mvi	a,15		; zapni preadresovanie pamati
		out	SYS55M
		call	MEMIN		; priprav systemove premenne pre
		dw	SysParams	; nacitanie prvej stopy systemu
		dw	12
		dw	DmaAdr
		call	SREAD		; precitaj prvu systemovu stopu
		jc	Error		; chyba
		jnz	Error		; chyba
		lxi	h,CcpAdr+25*128	; DMA pre druhu systemovu stopu
		shld	DmaAdr
		lxi	h,26*128-1	; LEN pre druhu systemovu stopu
		shld	Length
		mvi	a,1
		sta	Hlava		; HLAVA 1
		sta	Sektor		; SEKTOR 1
		call	SREAD		; precitaj druhu systemovu stopu
		jc	Error		; chyba
		jnz	Error		; chyba
		mvi	a,13		; odpoj ROM, pripoj RAM
		out	SYS55M
		jmp	BiosAdr		; skok do BIOSu

Error:		mvi	a,14		; vypni preadresovanie pamati
		out	SYS55M
		call	MEMIN		; vrat naspat povodny obsah pamate
		dw	005Ch		; od 0CFB0h
		dw	12
		dw	DmaAdr
		ret			; navrat do zakladneho monitora

;------------------------------------------------------------------------------
; systemove premenne pre nacitanie prvej stopy systemu
SysParams:	dw	CcpAdr		; DMA - CCP zacina na adrese 0B500h
		dw	25*128-1	; LEN - dlzka-1 v prvej systemovej stope 
		db	0		; DISK A:
		db	0		; STOPA
		db	0		; HLAVA
		db	2		; SEKTOR

; parametre diskety
		db	0,26,7,128	; N, EOT, GPL, DTL

;------------------------------------------------------------------------------

		if	($ > (BootAdr + BootLen))
		  error "BOOT je prilis dlhy!!!"
		else
		  db	((BootAdr + BootLen) - $) dup 0E5h
		endif

;------------------------------------------------------------------------------
